-- 4bit dez to 10bit I & Q encoder 

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY ten_bit_IQencXx IS 

	PORT(Din :IN  STD_LOGIC_VECTOR(3 DOWNTO 0);
		 Clk :IN STD_LOGIC;
		 I_Dout:OUT STD_LOGIC_VECTOR(9 DOWNTO 0);
		 Q_Dout:OUT STD_LOGIC_VECTOR(9 DOWNTO 0));
		 
END ten_bit_IQencXx;

ARCHITECTURE LogicFunction OF ten_bit_IQencXx IS
	
BEGIN
		
	PROCESS(Clk) 
		BEGIN 
			IF(clk'EVENT AND Clk = '1') THEN
			 
			CASE Din is
				WHEN "0000" => I_Dout <= "0010001001";
							   Q_Dout <= "1101111000"; 
				WHEN "0001" => I_Dout <= "0010001001";
							   Q_Dout <= "1001111110"; 
				WHEN "0010" => I_Dout <= "0010001001";
							   Q_Dout <= "0010001001";
				WHEN "0011" => I_Dout <= "0010001001"; 
							   Q_Dout <= "0110000100";
				WHEN "0100" => I_Dout <= "0110000100";
							   Q_Dout <= "1101111000";
				WHEN "0101" => I_Dout <= "0110000100";
							   Q_Dout <= "1001111110";
				WHEN "0110" => I_Dout <= "0110000100";
							   Q_Dout <= "0010001001";
				WHEN "0111" => I_Dout <= "0110000100";
							   Q_Dout <= "0110000100";
				WHEN "1000" => I_Dout <= "1101111000";
							   Q_Dout <= "1101111000";
				WHEN "1001" => I_Dout <= "1101111000";
							   Q_Dout <= "1001111110";
				WHEN "1010" => I_Dout <= "1101111000";
							   Q_Dout <= "0010001001";
				WHEN "1011" => I_Dout <= "1101111000";
							   Q_Dout <= "0110000100";
				WHEN "1100" => I_Dout <= "1001111110"; 
							   Q_Dout <= "1101111000";
				WHEN "1101" => I_Dout <= "1001111110";
							   Q_Dout <= "1001111110";
				WHEN "1110" => I_Dout <= "1001111110";
							   Q_Dout <= "0010001001";
				WHEN "1111" => I_Dout <= "1001111110";
							   Q_Dout <= "0110000100";
			END CASE;

			END IF; 
	END PROCESS;
	
END LogicFunction;